**********************************************************************
* Name:		xDB
* Interface:	( ob --> )
* Description:	Debug machine language
**********************************************************************
ASSEMBLE
	CON(1)	#8
RPL
xNAME DB
::
  DEPTH #0<> ?SKIP CK1

ASSEMBLE
DBPARSIZE	EQU (DBBUFSIZE)+8+5
RPL
  ' ID DBpar Sys@ ITE
* Validate existing DBpar
  ::
	CODE
		C=DAT1	A
		CD0EX
		D0=D0+	5
		A=DAT0	A
		CD0EX
		R1=C
		LC(5)	DBPARSIZE
		?A<C	A
		GOYES	+	PAR smaller than it should be, corrupt
		C=R1
		CD0EX
		D0=D0+	5
		A=DAT0	8
		D0=C
		LC(8)	(0)-(DBMAGIC)
		P=	7
		C=-C-1	WP
		?A#C	WP
		GOYES	+	Invalid magic - corrupt
+		P=	0
		GOVLNG	=OverWrT/FLp
	ENDCODE
	NOT?SEMI [#] XerrDBpar DO#EXIT
  ;
* Create new DBpar
  ::
ASSEMBLE
		CON(5)	=DOEXT0
		REL(5)	+
		CON(8)	(0)-(DBMAGIC)
+
RPL
	[#] DBBUFSIZE EXPAND
	CODE
		C=DAT1	A
		CD1EX
		D1=D1+	10
		A=DAT1	8
		A=-A-1	W
		DAT1=A	8
		D1=C
		GOVLNG	=Loop
	ENDCODE		
	' ID DBpar Sys!
  ;

* Check argument

  DUPTYPEIDNT? IT :: @ ?SEMI 0LastRomWrd! SETNONEXTERR ;
  DUPTYPEROMP? IT :: ROMPTR@ ?SEMI 0LastRomWrd! SETROMPERR ;
  DUPTYPECSTR? IT :: Entr># #>HXS ;

  ::
	CK&DISPATCH1
	THIRTYONE	DUPTWO
	#7F		ONE
	ELEVEN
	:: HXS>#
	   CODE
		GOSBVL	=POP#
		R0=A
		GOSBVL	=SAVPTR
		D0=A
		A=DAT0	A
		GOVLNG	=Push2#aLoop
	   ENDCODE
	   TWO
	;
	ZERO	:: ITE THREE FOUR ;
  ;

  THIRTYTHREE UserITE TWO ZERO
  THIRTYTWO UserITE
  :: #1+ CLOSEUART DOOPENIO NULLPAINT ;
  :: xFNT2 TOADISP TURNMENUOFF ;
  SWAP GetRplTab GetDisTab
* COLA					( D0 is modified.. )
  CODE
	INCLUDE	dbg/dbentry.a
	INCLUDE	dbg/dbkeywait.a
	INCLUDE	dbg/dbmain.a
	INCLUDE	dbg/dbarg.a
	INCLUDE	dbg/dbdis.a
	INCLUDE	dbg/cycles.a
	INCLUDE	dbg/dbview.a
	INCLUDE	dbg/dbdisp.a
	INCLUDE	dbg/dbmsg.a
	INCLUDE	dbg/dbstep.a
	INCLUDE	dbg/dbserver.a
	INCLUDE	dbg/dbread.a
	INCLUDE	dbg/dbwrite.a
  ENDCODE
;
**********************************************************************
