Couples(COUPLE.A)
{
[C]Couple Diagram 1
[D]Couple Diagram 2
M=Fd
d is the perpendicular
distance between F and -F
}
Equilibrium(EQUIL.A)
{
\GSF=0,\GSM=0
Example:
The uniform 100-kg I-Beam is
supported initially by its end
rollers on the horizontal
surface at A and B.  By means
of the cable at C it is desired
to elevate end B to a position
3 m above end A.  Determine the
required tension P, the reaction
A, and the angle \Gh made by
the beam with the horizontal
in the elevated position.
[C] before elevation
[D] after elevation
Solution:
\GSM_A=0
P(6 cos\Gh)-981(4 cos\Gh)=0
P=654 N
\GSF_Y=0
654 + R_A - 981 = 0
R_A = 327 N
sin\Gh = 3/8 = 22.0\^o
}
Center of Gravity(CENTER.A)
{
<_r>=\.S(<r>\GdM)/M
<_r>=\.S(<r>\Gr\GdV)/\.S(\Gr\GdV)
Example: ([C] Picture)
Find the center of mass of
a section of a circle of
radius r from -\Ga to \Ga
<y>=0 by symmetry
<x>=\.S(x_c\GdA)/A
x_c=(r0*sin\Ga)/\Ga
A=2*\Ga*r^2
\GdA=2*r0*\Gdr0 (A=len*width)
<x>*A=
\.S|0 to r|(x_c*2r0\Ga*\Gdr0)
<x>=((2/3)r^3*sin\Ga)/(r^2*a)
<x>=(2/3)((r*sin\Ga)/\Ga)
}
Distributed Loads(DISTRIB.A)
{
\GdR=w\Gdx
R=\.Sw\Gdx
R<x>=\.Sxw\Gdx
<x>=(\.Sw\Gdx)/R
Example:
Determine the reaction at the
support A of the loaded
cantilever beam. [C] picture.
given:
Weight at A = 1000 N/m
Weight at B = 2024 N/m
Weight varies as:
w=w0+k*x^3
Solution:
w0=1000 N/m
k=2 N/m^4
R=\.S(w\Gdx)=
\.S|0 8|(1000+2*x^3)\Gdx
=(1000*x+(x^4)/2)|0 8|
=10048 N
<x>=(\.Sxw\Gdx)/R
=(1/10048)*
\.S|0 8|(x(1000 + 2x^3)\Gdx
=(1/10048)*
(500*x^2+(2/5)*x^5)|0 8|
=4.49m
From free body diagram [C]
we have:
\GSMa=0
Ma-(10048)(4.49)=0
Ma=45100 Nm
\GSFy=0
Ay=10048 N
Ax=0 (no movement in x
direction)
}
Friction ()
{
Fk=k*N
F_max=s*N
Tan s=s
Tan k=k
}
Virtual Work(VIRTUAL.A)
{
\GdU=F\Gdr
U=\.S(F\Gdr)
\GdU=M*=\Gd\Gh
U=\.S(M\Gd\Gh)
.\GdU=F.\Gdr
.\GdU=M.\Gd\Gh
At equilibrium
.\GdU=0
For a spring:
.\GdU=kx.\Gdx
Example:
l=length of beam.
[C] Picture.
P.\Gdx+2mg.\Gdh=0
x=2*l*sin(\Gh/2)
.\Gdx=l*cos(\Gh/2).\Gd\Gh
h=(l/2)*cos(\Gh/2)
.\Ghh=-(1/4)*sin(\Gh/2).\Gd\Gh
P*l*cos(\Gh/2).\Gd\Gh
-2mg*(1/4)*sin(\Gh/2).\Gd\Gh=0
tan(\Gh/2)=(2P)/(mg)
\Gh=2*atan(2p/mg)
}
Potential Energy(POTENT.A)
{
V=\.S|0 X|(F\Gdx)
=\.S|0 X|(kx\Gdx)
V=(1/2)(k*x^2)
.\GdV=F*.\Gdx=kx.\Gdx
Gravity:
Vg=mgh
.\GdU'=.\GdV
Equilibrium Conditions:
Equilibrium V'=0
Stable V''>0
Unstable V''<0
Example:
V=(1/2)kx^2
V=(1/2)k(2b*sin(\Gh/2))^2
V=2kb^2sin^2(\Gh/2)
Vg=0 at O and C
Potential weight for object.
Vg=2mg(-b*cos(\Gh/2))
x=4b*sin(\Gh/2)
.\Gdx=2b*cos(\Gh/2).\Gd\Gh
.\GdU'=P.\Gdx
=2Pb*cos(\Gh/2).\Gd\Gh
.\GdU'=.\GdVg+.\GdV
2Pb*cos(\Gh/2).\Gd\Gh=
.\Gd(2kb^2sin^2(\Gh/2))
+.\Gd(-2mgb*cos(\Gh/2))
=2kb^2*sin(\Gh/2)*cos(\Gh/2).\Gd\Gh
+mgb*sin(\Gh/2).\Gd\Gh
P=kb*sin(\Gh/2)+(1/2)mg*tan(\Gh/2)
}
#end
