**********************************************************************
*		Jazz Assembler
**********************************************************************

**********************************************************************
*		Main Program
**********************************************************************
ASSEMBLE
	CON(1)	#8
RPL
xNAME ASS
::
  CK1
  CHECKME		( Error if lib is hidden )
  :: STRIPTAGS DUPTYPECSTR? ?SEMI
     SETTYPEERR
  ;

* If debugging with MLDL here is needed:
* RECLAIMDISP TURNMENUOFF
* Else SetupAssOps will put user options to wrong location

  GetRplTab			( --> $src $tab )
  MakeAssStat$			( --> $src $tab $status )
  SetupAssOps			( Fetch user options into $status )

  NULL$TEMP			( $src $tab $status $buffer )
  4ROLL				( $tab $status $buffer $src )
  Assemble
  DROP UNROT2DROP		( --> $buffer )

;
**********************************************************************
*		Subroutines
**********************************************************************

**********************************************************************
* Input: ( $tab $status $buffer $src )
* Output: ( $tab $status $buffer $src )
**********************************************************************
NULLNAME Assemble

ASSEMBLE
		CON(5)	=DOCODE
		REL(5)	->AssEnd
		INCLUDE	ass/assemble.a
		INCLUDE ass/assrpl.a
		INCLUDE ass/parse.a
		INCLUDE ass/asscode.a
		INCLUDE	ass/symbols.a
		INCLUDE ass/error.a
		INCLUDE	ass/assdisp.a
->AssEnd
RPL

**********************************************************************
* Make assembler status buffer to bottom of tempob area.
* Makes it big enough to use even page method.
* The address of the buffer will not change unless:
*	1) ROMPTAB changes
*	2) One of the display grob sizes is changed
* Neither of above can happen while the assembler loop is running
**********************************************************************
( --> $status )
NULLNAME MakeAssStat$

CODE
		GOSBVL	=SAVPTR
		LC(5)	(ASSBUFSIZE)+256
		GOSUBL	MAKEBOT$N
		GOVLNG	=GPPushR0Lp
ENDCODE

**********************************************************************
* Fetch user options into status buffer.
* Interface: ( $status --> $status' )
* Note: TestFlag uses ST0 which is ok since ST0 is not an option
*	but a temporary flag.
**********************************************************************

( $status --> $status' )

NULLNAME SetupAssOps
CODE
		GOSBVL	=SAVPTR
		A=DAT1	A
		A=A+CON	A,10
		A=0	B
		LC(5)	#100
		A=A+C	A
		D1=A

		D1=(2)	O_ST_SAVE
		C=DAT1	X
		ST=C		* Just in case there already were some flags..

		LC(2)	1
		GOSUB	UserFlag?
		ST=0	qREPORT
		GONC	+
		ST=1	qREPORT
+		C=ST
		DAT1=C	X
		GOVLNG	=GETPTRLOOP

UserFlag?	ST=1	0
Flag?		A=0	A
		A=C	B
		GOSBVL	=TestFlag
		C=C&A	XS
		?C#0	XS
		RTNYES
		RTN

SysFlag?	ST=0	0
		GOTO	Flag?
ENDCODE
**********************************************************************
